function pdf = BMpdf2(y,S0,r,q,T,L,beta,a,b,c,tau)

% Brigo, Mercurio, and Rapisarda Risk Neutral Density
% by Fabrice Douglas Rouah, FRouah.com and Volopta.com

N = length(L);
mu = r-q;

% eta(i) volatilities and Vi(T)
for i=1:N
    eta(i) = a(i) + b(i)*(1-exp(-T/tau(i)))*(tau(i)/T) + c(i)*exp(-T/tau(i));
    V(i) = eta(i)*sqrt(T);
end

for i=1:N
    betaexp = beta(i)*exp(mu*T);
    % RND only defined for y > betaexp
    if y >= betaexp
        p(i) = 1/(y-betaexp)/V(i)/sqrt(2*pi) ...
            * exp(-0.5/V(i)^2*(log((y-betaexp)/(S0-beta(i))) - mu*T + 0.5*V(i)^2)^2);
    else
        p(i) = 0;
    end
    p(i) = L(i)*p(i);
end

pdf = sum(p);
